command = xplor.command
from xplor import select
from pdbTool import *
from atomAction import *
from selectTools import *
from simulationTools import *
import string


command("""
 structure @../Psf/sry_wt.psf 
           @../Psf/axis_new.psf
           @../Psf/sry_dna.psf
           @../Psf/axis_600.psf
           @../Psf/axis_700.psf
 end

 param @../TopPar/parallhdg_new.pro
       @../TopPar/parnah1er1_mod_new.inp
       @../TopPar/par_axis_3.pro 
 end
 set echo = on message = on end
""")

command("""
 vector iden (store9) (   ( resid 4:79 and (name CA or name N or name C))  
                        or ( resid 102     and not hydro ) 
                        or ( resid 104:113 and not hydro ) 
                        or ( resid 116:127 and not hydro ) 
                                                                  )
 vector iden (store8) (   
                           ( resid 4:79 and not hydro)
                        or ( resid 102     and not hydro )
                        or ( resid 104:113 and not hydro )
                        or ( resid 116:127 and not hydro )
                                                                  )
 vector iden (store7) (
                           ( resid 4:79 and not hydro )
                                                                  )
""")
                       
av = 0.0 ; av2 = 0.0 ; avP = 0.0; 
rms={}; rms2={}; rmsP={}; 

totn = 40

for cn in range(0,totn):
   command(" coor disp=comp @../Structures/aveNoConju.chr")
   fname = "../Structures/s_saNoConju_%-d.pdb" % (cn+1)
   command(" coor @%s" % fname) 
   result = command("""
              coor sele=(recall 9) fit end
              coor sele=(recall 9) rms end
            """, "rms" )
   av += float(result[0]) / float(totn)
   rms[cn] = float(result[0])

   result = command("""
              coor sele=(recall 8) fit end
              coor sele=(recall 8) rms end
            """, "rms" )
   av2 += float(result[0]) / float(totn)
   rms2[cn] = float(result[0])

   result = command("""
              coor sele=(recall 7) fit end
              coor sele=(recall 7) rms end
            """, "rms" )
   avP += float(result[0]) / float(totn)
   rmsP[cn] = float(result[0])


   pass
std = 0.0; std2 = 0.0; stdP = 0.0; 
for cn in range(0,totn):
   print " %3d  rms from correct structure: %7.3f" % (cn+1, rms[cn])
   std  += (rms[cn]  - av ) ** 2.0
   std2 += (rms2[cn] - av2) ** 2.0 
   stdP += (rmsP[cn] - avP) ** 2.0     

std  = sqrt( std  / float(totn) )
std2 = sqrt( std2 / float(totn) )
stdP = sqrt( stdP / float(totn) )
   
print "average rms = %7.3f +/- %-7.3f (protein bb    + dna heavy)" % (av, std)
print "average rms = %7.3f +/- %-7.3f (protein heavy + dna heavy)" % (av2, std2)
print "average rms = %7.3f +/- %-7.3f (protein heavy            )" % (avP, stdP)

