#!/bin/csh

set target = "s_saNoConju_[1-9].pdb s_saNoConju_1[0-9].pdb s_saNoConju_2[0-9].pdb s_saNoConju_3[0-9].pdb s_saNoConju_40.pdb"

echo "\nThe following files are investigated:"
echo `ls $target`
echo "\n"


set a = `grep "bond" $target | awk '{s += $3} END {print s / NR}'`
set b = `grep "bond" $target | awk -v k=$a '{s += ($3-k)^2} END {print sqrt(s / NR)}'`
echo "bond rms : $a $b"

set a = `grep "angl" $target | awk '{s += $5} END {print s / NR}'`
set b = `grep "angl" $target | awk -v k=$a '{s += ($5-k)^2} END {print sqrt(s / NR)}'`
echo "angl rms : $a $b"

set a = `grep "impr" $target | awk '{s += $7} END {print s / NR}'`
set b = `grep "impr" $target | awk -v k=$a '{s += ($7-k)^2} END {print sqrt(s / NR)}'`
echo "impr rms : $a $b"


set a = `grep "noe" $target | grep -v "violation" | awk '{s += $3} END {print s / NR}'`
set b = `grep "noe" $target | grep -v "violation" | awk -v k=$a '{s += ($3-k)^2} END {print sqrt(s / NR)}'`
echo "noe rms : $a $b"


set a = `grep "cdih" $target | grep -v "violation" | awk '{s += $5} END {print s / NR}'`
set b = `grep "cdih" $target | grep -v "violation" | awk -v k=$a '{s += ($5-k)^2} END {print sqrt(s / NR)}'`
echo "cdih rms : $a $b"


set a = `grep "13CA shift" $target | awk '{s += $4} END {print s / NR}'`
set b = `grep "13CA shift" $target | awk -v k=$a '{s += ($4-k)^2} END {print sqrt(s / NR)}'`
echo "13CA shift rms : $a $b"


set a = `grep "13CB shift" $target | awk '{s += $7} END {print s / NR}'`
set b = `grep "13CB shift" $target | awk -v k=$a '{s += ($7-k)^2} END {print sqrt(s / NR)}'`
echo "13CB shift rms : $a $b"

set a = `grep "coup" $target | awk '{s += $7} END {print s / NR}'`
set b = `grep "coup" $target | awk -v k=$a '{s += ($7-k)^2} END {print sqrt(s / NR)}'`
echo "JHNHA rms : $a $b"

set a = `grep "XDIP HHp" $target | awk '{s += $10} END {print s / NR}'`
set b = `grep "XDIP HHp" $target | awk -v k=$a '{s += ($10-k)^2} END {print sqrt(s / NR)}'`
echo "XDIP HHp rms : $a $b"


echo "### R-factors for residual dipolar coupling data ###"
set a = `grep "JNH" $target | grep -v "JNHd" | awk '{s += $5} END {print s / NR}'`
set b = `grep "JNH" $target | grep -v "JNHd" | awk -v k=$a '{s += ($5-k)^2} END {print sqrt(s / NR)}'`
echo "JNH : $a $b"


set a = `grep "JCH" $target | grep -v "JCHd" | awk '{s += $5} END {print s / NR}'`
set b = `grep "JCH" $target | grep -v "JCHd" | awk -v k=$a '{s += ($5-k)^2} END {print sqrt(s / NR)}'`
echo "JCH : $a $b"


set a = `grep "JNCO" $target | awk '{s += $5} END {print s / NR}'`
set b = `grep "JNCO" $target | awk -v k=$a '{s += ($5-k)^2} END {print sqrt(s / NR)}'`
echo "JNCO : $a $b"


set a = `grep "JHNC" $target | awk '{s += $5} END {print s / NR}'`
set b = `grep "JHNC" $target | awk -v k=$a '{s += ($5-k)^2} END {print sqrt(s / NR)}'`
echo "JHNC : $a $b"


set a = `grep "JNHd" $target | awk '{s += $5} END {print s / NR}'`
set b = `grep "JNHd" $target | awk -v k=$a '{s += ($5-k)^2} END {print sqrt(s / NR)}'`
echo "JNHd : $a $b"


set a = `grep "JCHd" $target | awk '{s += $5} END {print s / NR}'`
set b = `grep "JCHd" $target | awk -v k=$a '{s += ($5-k)^2} END {print sqrt(s / NR)}'`
echo "JCHd : $a $b"


